<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des statuts n'ont pas pu être chargées."
    />
    <template v-else-if="followUpStatusCounts">
      <h2 class="fr-h5">Statuts</h2>
      <StatsPie
        v-if="followUpStatusCounts.length"
        pie-label="Répartion des statuts"
        :stats="followUpStatusCounts"
        :total-count="totalCount"
      />
      <p v-else>{{ emptyResultMessage }}</p>
    </template>
  </div>
</template>

<script setup>
  import {
    HELP_REQUEST_STATUS_COLORS,
    INTERVIEW_STATUS_COLORS
  } from '~/utils/constants/chart'
  import { HELP_REQUEST_STATUS_OPTIONS } from '~/utils/constants/help-requests'
  import { INTERVIEW_STATUS_OPTIONS } from '~/utils/constants/interview'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    totalCount: {
      type: Number,
      required: true
    },
    collection: {
      type: String,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: followUpStatusCounts,
    pending,
    error
  } = useLazyAsyncData(
    `${props.collection}FollowUpStatusCounts`,
    loadFollowUpStatusCounts,
    {
      server: false
    }
  )

  const emptyResultMessage = computed(() => {
    return `Commencez à créer des ${
      props.collection === 'help_requests'
        ? "instructions de demande d'aides"
        : "synthèses d'entretien"
    } dans les fiches de bénéficiaires pour voir apparaître les statistiques de la répartition des statuts.`
  })

  async function loadFollowUpStatusCounts() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems(props.collection, {
      groupBy: 'status',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const followUpStatusCounts = res.data.data.map(
        ({ status, countDistinct }) => ({
          key: status,
          label: labelOrUnprovided(
            status,
            props.collection === 'help_requests'
              ? HELP_REQUEST_STATUS_OPTIONS
              : INTERVIEW_STATUS_OPTIONS
          ),
          color: statusColor(status),
          count: parseInt(countDistinct.id)
        })
      )
      followUpStatusCounts.sort((a, b) => b.count - a.count)
      return followUpStatusCounts
    }
    throw new Error(errorResponseMessage(res))
  }

  function statusColor(status) {
    return props.collection === 'help_requests'
      ? HELP_REQUEST_STATUS_COLORS[status]
      : INTERVIEW_STATUS_COLORS[status]
  }
</script>
